from operator import itemgetter
from brain import Brain
from util import pyconfig
from numpy import average

STATUS = []

class Brains(object):
    def __init__(self, config, entity='brain'):
        if not isinstance(config, dict):
            config = pyconfig.read(config)
        self._datafile = config['data']
        self._attention = 0.0
        self._raw_attention = []
        self._meditation = 0.0
        self._raw_meditation = []

    def set(self, id, attention, meditation):
        self._raw_attention = attention
        self._raw_meditation = meditation
        self._attention = average(attention[-3:])
        self._meditation = average(meditation[-3:])
        print attention, meditation

        data = dict()
        data['id'] = str(id)
        data['entity_type'] = 'brain'
        data['relevance'] = 1.0
        data['metadata'] = self._status(id)

        return [ Brain(data['id'], data['entity_type'].lower(), data['relevance'], data['metadata']) ]

    def _status(self, id):
        metadata = dict()
        metadata['raw_attention'] = str(self._raw_attention)
        metadata['raw_meditation'] = str(self._raw_meditation)
        metadata['avg_attention'] = self._attention
        metadata['avg_meditation'] = self._meditation
        metadata['status'] = self._text(id)
        metadata['img'] = self._img(id)
        return metadata

    def status(self, id=1):
        data = open(self._datafile).readlines()[0]
        data = data.strip('\n').split('\t')
        attention = eval(data[0])
        meditation = eval(data[1])
        self._raw_attention = attention
        self._raw_meditation = meditation
        self._attention = average(attention[-3:])
        self._meditation = average(meditation[-3:])
        print attention, meditation

        data = dict()
        data['id'] = str(id)
        data['entity_type'] = 'brain'
        data['relevance'] = 1.0
        data['metadata'] = self._status(id)

        return [ Brain(data['id'], data['entity_type'].lower(), data['relevance'], data['metadata']) ]

    def _img(self, id):
        return 'budha-1'

    def _text(self, id):
        return 'Foo bar!'


if __name__ == "__main__":
    import sys
    from util import pyconfig

    config_file = sys.argv[1]
    config = pyconfig.read(config_file)
    entity_type = sys.argv[2]

    item = Items(config['collections'][entity_type], entity=entity_type)
    print item.status()
