try:
    import lucene as pylucene
except:
    import PyLucene as pylucene

class Read(object):
    def __init__(self, indexName):
        self.reader = pylucene.IndexReader.open(indexName)

    def delete(self, key, value):
        print 'Warning: use with care. Some terms might not be recognized.'
        t = pylucene.Term(key,value)
        return self.reader.deleteDocuments(t)

    def deletes(self,key, values):
        removed = 0
        for i in range(self.reader.maxDoc()):
            if self.reader.isDeleted(i):
                continue
            d = self.reader.document(i)
            val = d.get(key)
            if val in values:
                self.reader.deleteDocument(i)
                removed +=1
        return removed

    def close(self):
        self.reader.close()

